<script lang="ts">
	import Saos from 'saos';
	import { onMount } from 'svelte';

	// TODO:
	// Fill out members array with the following structure:
	let membersPre = [
		{
			name: 'Mathilde BARD',
			role: 'Présidente',
			image: '/team/Mathilde.png',
			desc: 'Oui'
		},
		{
			name: 'Théo Rovillo',
			role: 'Présidence',
			image: '/team/Théo.png',
			desc: 'Oui'
		},
		{
			name: 'Augustin DESBOIS',
			role: 'Présidence',
			image: '/team/Augustin.png',
			desc: 'Oui'
		},
		{
			name: 'Lola MONTIGNIER',
			role: 'Trésorerie',
			image: '/team/Lola.png',
			desc: 'Oui'
		},
		{
			name: 'Chad LEPECUCHELLE',
			role: 'Trésorerie',
			image: '/team/Chad.png',
			desc: 'Oui'
		},
		{
			name: 'Titouan CHAUVINEAU',
			role: 'Secrétaire',
			image: '/team/Chauvineau.jpg',
			desc: 'Oui'
		},
		{
			name: 'Nicolas FERNANDEZ',
			role: 'Secrétaire',
			image: '/team/Nicolas.png',
			desc: 'Oui'
		},
		{
			name: 'Ugo BIRKEL',
			role: 'Respo Twitch',
			image: '/team/Birkel.png',
			desc: 'Oui'
		},
		{
			name: 'Titouan COUVRAT-PAILLE',
			role: 'Respo Graphisme',
			image: '/team/Tituan.png',
			desc: 'Oui'
		},
		{
			name: 'Tanguy BOURA',
			role: "Respo Com'",
			image: '/team/Tanguy.png',
			desc: 'Oui'
		},
		{
			name: 'Alex Zhou',
			role: "Respo Com'",
			image: '/team/Alex.png',
			desc: 'Oui'
		},
		{
			name: 'Abel VAGNE',
			role: "Respo Com'",
			image: '/team/Abel.png',
			desc: 'Oui'
		},
		{
			name: 'Tom GOUVILLE',
			role: 'Respo Site',
			image: '/logo.png',
			desc: 'Oui'
		},
		{
			name: 'Tristan SMAGGHE',
			role: 'Respo Site',
			image: '/logo.png',
			desc: 'Oui'
		},
		{
			name: 'Grégoire CHEVALIER',
			role: "Respo Log'",
			image: '/team/Grégoire.png',
			desc: 'Oui'
		},
		{
			name: 'Clément TEXIER',
			role: "Respo Log'",
			image: '/team/Texier.png',
			desc: 'Oui'
		},
		{
			name: 'Juila BERNON',
			role: 'Respo Sponsos',
			image: '/team/Julia.png',
			desc: 'Oui'
		},
		{
			name: 'Clément COUCHEVELLOU',
			role: 'Respo Sponsos',
			image: '/team/Clement.png',
			desc: 'Oui'
		},
		{
			name: 'Amandine LAPIQUE-FAVRE',
			role: 'Respo Sponsos',
			image: '/team/Amandine.png',
			desc: 'Oui'
		},
		{
			name: 'Victor LEVREL',
			role: 'Respo Sponsos',
			image: '/team/Victor.png',
			desc: 'Oui'
		},
		{
			name: 'Maxime WIRTH',
			role: 'Démarchage streamers',
			image: '/team/Maxime.png',
			desc: 'Oui'
		},
		{
			name: 'Hugo BRINES',
			role: 'Démarchage streamers',
			image: '/team/Brines.png',
			desc: 'Oui'
		}
	];

	// member type
	interface Member {
		name: string;
		role: string;
		image: string;
		desc: string;
	}

	let members: Member[] = [];

	onMount(() => {
		// fill members slowly
		let i = 0;
		let interval = setInterval(() => {
			let tempMembers = members;
			tempMembers.push(membersPre[i]);
			members = tempMembers;
			i++;
			if (i >= membersPre.length) clearInterval(interval);
		}, 100);
	});

	let chooseAnimation = (i: number) => {
		// sm
		if (window.innerWidth < 760) {
			return 'from-left 0.5s cubic-bezier(0.35, 0.5, 0.65, 0.95) both';
		}
		// md
		if (window.innerWidth < 1000 && window.innerWidth > 760) {
			switch (i % 2) {
				case 0:
					return 'from-left 0.5s cubic-bezier(0.35, 0.5, 0.65, 0.95) both';
				case 1:
					return 'from-right 0.5s cubic-bezier(0.35, 0.5, 0.65, 0.95) both';
			}
		}
		// lg
		switch (i % 3) {
			case 0:
				return 'from-left 0.5s cubic-bezier(0.35, 0.5, 0.65, 0.95) both';
			case 1:
				return 'from-top 0.5s cubic-bezier(0.35, 0.5, 0.65, 0.95) both';
			case 2:
				return 'from-right 0.5s cubic-bezier(0.35, 0.5, 0.65, 0.95) both';
		}
	};

	// Provide random transformations for each member
	function chooseStyle(i: number) {
		// md & sm
		if (window.innerWidth < 1000) {
			switch (i % 3) {
				case 0:
					return 'background-color: rgb(254 215 170);';
				case 1:
					return 'background-color: rgb(254 225 170);';
				case 2:
					return 'background-color: rgb(254 215 180);';
			}
		}
		// lg
		switch (i % 3) {
			case 0:
				return 'transform: translateY(-50px); background-color: rgb(254 215 170);';
			case 1:
				return 'transform: translateY(50px); background-color: rgb(254 225 170);';
			case 2:
				return 'transform: translateY(150px); background-color: rgb(254 215 180);';
		}
	}
</script>

<div class="flex flex-row w-full justify-center">
	<div class="grid grid-cols-1 md:grid-cols-2 lg:grid-cols-3 mt-8 px-4 md:px-36 md:p-12 gap-8 md:gap-12">
		{#each members as member, i}
			<Saos animation={chooseAnimation(i)}>
				<!-- randomize a bit the placement with a set seed -->
				<div class="flex flex-row drop-shadow-xl rounded-xl p-5" style={chooseStyle(i)}>
					<img src={member.image} alt="logo tn event" class="h-32 w-32 drop-shadow-lg rounded-xl" />
					<div class="flex w-full justify-center">
						<div class="flex flex-col justify-center">
							<div class="text-2xl font-bold text-center">{member.name}</div>
							<div class="text-center">{member.role}</div>
						</div>
					</div>
				</div>
			</Saos>
		{/each}
	</div>
</div>

<style>
	@keyframes -global-from-left {
		0% {
			transform: rotateX(50deg) translateX(-10vw) skewX(-50deg);
			opacity: 1;
		}
		100% {
			transform: rotateX(0deg) translateX(0) skewX(0deg);
			opacity: 1;
		}
	}

	@media (max-width: 640px) {
		@keyframes -global-from-right {
			0% {
				transform: rotateX(50deg) translateX(-10vw) skewX(-50deg);
				opacity: 1;
			}
			100% {
				transform: rotateX(0deg) translateX(0) skewX(0deg);
				opacity: 1;
			}
		}
		@keyframes -global-from-top {
			0% {
				transform: rotateX(50deg) translateX(-10vw) skewX(-50deg);
				opacity: 1;
			}
			100% {
				transform: rotateX(0deg) translateX(0) skewX(0deg);
				opacity: 1;
			}
		}
	}
	@media (min-width: 640px) {
		@keyframes -global-from-right {
			0% {
				transform: rotateX(50deg) translateX(10vw) skewX(-50deg);
				opacity: 1;
			}
			100% {
				transform: rotateX(0deg) translateX(0) skewX(0deg);
				opacity: 1;
			}
		}
		@keyframes -global-from-top {
			0% {
				transform: rotateX(50deg) translateY(-10vh) skewX(-50deg);
				opacity: 1;
			}
			100% {
				transform: rotateX(0deg) translateY(0) skewX(0deg);
				opacity: 1;
			}
		}
	}
</style>
